Index: soft/giet_vm/giet_fat32/fat32.c
===================================================================
--- soft/giet_vm/giet_fat32/fat32.c	(revision 569)
+++ soft/giet_vm/giet_fat32/fat32.c	(revision 587)
@@ -1575,227 +3544,811 @@
 unsigned int p       = procid & ((1<<P_WIDTH)-1);
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] enters for file %s\n"
-        " - buffer vbase    = %x\n"
-        " - skipped sectors = %x\n"
-        " - write sectors   = %x\n"
-        " - file sectors    = %x\n"
-        " - need_allocate   = %d\n",
-        x, y, p, _fat.fd[fd_id].name, (unsigned int)buffer,
-        offset, count, file_sectors, allocate );
-#endif
-
-    // arguments checking
-    if ( fd_id >= GIET_OPEN_FILES_MAX )
-    { 
-        _printf("\n[FAT ERROR] in _fat_write() : illegal file descriptor index\n");
+_printf("\n[DEBUG FAT] _fat_remove() : P[%d,%d,%d] enters for path <%s>\n",
+        x, y, p, pathname );
+#endif
+
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_remove() : FAT not initialised\n");
         return -1;
     }
-    if ( _fat.fd[fd_id].used != 1 )
-    {
-        _printf("\n[FAT ERROR] in _fat_write() : file not open\n");
+
+    // take the lock 
+    _spin_lock_acquire( &_fat.fat_lock );
+
+    // get searched file inode 
+    unsigned int code = _get_inode_from_path( pathname , &inode );
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_remove() : P[%d,%d,%d] found inode %x for <%s> / code = %d\n",
+        x , y , p , (unsigned int)inode , pathname , code );
+#endif
+
+    if ( (code == 1) || (code == 2) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_remove() : file <%s> not found\n", 
+                pathname );
+        return -2;
+    }
+    else if ( code == 3 )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_remove() : name too long in <%s>\n",
+                pathname );
+        return -3;
+    }
+
+    // check inode type
+    if ( (inode->is_dir != 0) && (should_be_dir == 0) ) 
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_remove() : <%s> is a directory\n",
+                pathname );
+        return -4;
+    }
+    if ( (inode->is_dir == 0) && (should_be_dir != 0) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_remove() : <%s> is not a directory\n", 
+                pathname );
+        return -4;
+    }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_remove() : P[%d,%d,%d] checked inode type for <%s>\n",
+        x , y , p , pathname );
+#endif
+    
+    // check references count for a file
+    if ( (inode->is_dir == 0) && (inode->count != 0) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_remove() : file <%s> still referenced\n",
+                pathname );
+        return -5;
+    }
+
+    //  check empty for a directory
+    if ( inode->is_dir )
+    {
+        unsigned int entries;
+        if ( _get_nb_entries( inode , &entries ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_remove() : cannot scan directory <%s>\n", 
+                    pathname );
+            return -6;
+        }
+        else if ( entries > 2 )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_remove() : directory <%s> not empty\n", 
+                    pathname );
+            return -7;
+        }
+    }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_remove() : P[%d,%d,%d] checked remove condition OK for <%s>\n",
+        x , y , p , pathname );
+#endif
+    
+    // remove the file or directory from the file system
+    if ( _remove_node_from_fs( inode ) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_remove() : cannot remove <%s> from FS\n",
+                pathname );
+        return -8;
+    }
+
+    // release lock and return success
+    _spin_lock_release( &_fat.fat_lock );
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_remove() : P[%d,%d,%d] removed  <%s> from FS\n",
+        x, y, p, pathname );
+#endif
+    
+    return 0;
+        
+}  // end _fat_remove()
+
+
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// This function implements the giet_fat_rename() system call.
+// It moves an existing file or directory from one node (defined by "old_path"
+// argument) to another node (defined by "new_path" argument) in the FS tree. 
+// The type (file/directory) and content are not modified.
+// If the new_path file/dir exist, it is removed from the file system, but only  
+// if the remove condition is respected (directory empty / file not referenced).
+// The removed entry is only removed after the new entry is actually created.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns 0 if success.
+// Returns a negative value if error:
+//  -1  : "FAT not initialised"
+//  -2  : "old_path not found"
+//  -3  : "new_path not found"
+//  -4  : "cannot scan to_remove directory"
+//  -5  : "to_remove directory not empty"
+//  -6  : "to_remove file still referenced"
+//  -7  : "cannot add new node to new_parent directory"
+//  -8  : "cannot update new_parent directory on device"
+//  -9  : "cannot remove old node from old_parent directory"
+//  -10 : "cannot update old_parent directory on device"
+//  -11 : "cannot remove to_remove node from FS"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_rename( char*  old_path,
+                 char*  new_path )
+{
+    fat_inode_t*  inode;        // anonymous inode pointer
+    fat_inode_t*  old;          // inode identified by old_path      => to be deleted
+    fat_inode_t*  new;          // inode identified by new_path      => to be created
+    fat_inode_t*  old_parent;   // parent inode  in old_path         => to be modified
+    fat_inode_t*  new_parent;   // parent inode  in new_path         => to be modified
+    fat_inode_t*  to_remove;    // previouly identified by new_path  => to be removed
+    unsigned int  code;
+
+#if GIET_DEBUG_FAT
+unsigned int procid  = _get_procid();
+unsigned int x       = procid >> (Y_WIDTH + P_WIDTH);
+unsigned int y       = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
+unsigned int p       = procid & ((1<<P_WIDTH)-1);
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_rename() : P[%d,%d,%d] enters to move <%s> to <%s>\n",
+        x , y , p , old_path , new_path );
+#endif
+
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_rename() : FAT not initialised\n");
         return -1;
     }
-    if ( ((unsigned int)buffer & 0x1FF) != 0 )
-    {
-        _printf("\n[FAT ERROR] in _fat_write() : memory buffer not sector aligned\n");
+
+    // take the lock 
+    _spin_lock_acquire( &_fat.fat_lock );
+
+    // get "old" and "old_parent" inode pointers
+    if ( _get_inode_from_path( old_path , &inode ) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_rename() : <%s> not found\n", old_path );
+        return -2;
+    }
+    else
+    {
+        old        = inode;
+        old_parent = inode->parent;
+    }
+
+    // get "to_removed" and "new_parent" inode pointers
+    code = _get_inode_from_path( new_path , &inode );
+
+    if ( code == 0 )       // new_path inode already exist 
+    {
+        to_remove        = inode;
+        new_parent       = inode->parent;   
+    }
+    else if ( code == 1 )  // to_remove does not exist but parent exist
+    {
+        to_remove        = NULL;
+        new_parent       = inode;
+    }
+    else                   // parent directory in new_path not found
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_rename() : <%s> not found\n", new_path );
+        return -3;
+    }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+{
+if ( to_remove )
+_printf("\n[DEBUG FAT] _fat_rename() : old_parent = %s / old = %s / new_parent = %s "
+        "/ to_remove = %s\n",
+        old_parent->name , old->name , new_parent->name , to_remove->name );
+else
+_printf("\n[DEBUG FAT] _fat_rename() : old_parent = %s / old = %s / new_parent = %s "
+        "/ no remove\n", 
+        old_parent->name , old->name , new_parent->name );
+}
+#endif
+
+    // check remove condition for "to_remove" inode
+    if ( to_remove )
+    {
+        if ( to_remove->is_dir )   // it's a directory
+        {
+            unsigned int entries;
+            if ( _get_nb_entries( to_remove , &entries ) )
+            {
+                _spin_lock_release( &_fat.fat_lock );
+                _printf("\n[FAT ERROR] in _fat_rename() : cannot scan directory <%s>\n", 
+                        to_remove->name );
+                return -4;
+            }
+            else if ( entries > 2 )
+            {
+                _spin_lock_release( &_fat.fat_lock );
+                _printf("\n[FAT ERROR] in _fat_rename() : directory <%s> not empty\n", 
+                        to_remove->name );
+                return -5;
+            }
+        }
+        else                       // it's a file
+        {
+            if ( to_remove->count ) 
+            {
+                _spin_lock_release( &_fat.fat_lock );
+                _printf("\n[FAT ERROR] in _fat_rename() : file <%s> still referenced\n", 
+                        to_remove->name );
+                return -6;
+            }
+        }
+    }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[FAT DEBUG] _fat_rename() : P[%d,%d,%d] checked remove condition OK\n",
+        x , y , p );
+#endif
+
+    // get new last name / error checking already done by _get_inode_from_path()
+    char  new_name[32];
+    _get_last_name( new_path , new_name );
+
+    // allocate "new" inode
+    new = _allocate_one_inode( new_name,
+                               old->is_dir,
+                               old->cluster,
+                               old->size,
+                               0,              // count
+                               0,              // dentry
+                               0 );            // no cache_allocate
+ 
+    // give the "old" File-Cache to the "new inode
+    new->levels = old->levels;
+    new->cache  = old->cache;
+
+    // add "new" to "new_parent" directory File-Cache
+    if ( _add_dir_entry( new , new_parent ) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_rename() : cannot add <%s> into <%s>\n",
+                new->name , new_parent->name );
+        return -7;
+    }
+
+    // add "new" to "new_parent" directory in Inode-Tree
+    _add_inode_in_tree( new , new_parent );
+    
+    // updates "new_parent" directory on device
+    if ( _update_device_from_cache( new_parent->levels,
+                                    new_parent->cache,
+                                    new_parent->name ) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_rename() : cannot update <%s> on device\n",
+                    new_parent->name );
+        return -8;
+    }
+
+    // remove "old" from "old_parent" File-Cache 
+    if ( _remove_dir_entry( old ) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_rename() : cannot remove <%s> from <%s>\n",
+                old->name , old_parent->name );
+        return -9;
+    }
+ 
+    // remove "old" inode from Inode-Tree
+    _remove_inode_from_tree( old );
+
+    // updates "old_parent" directory on device
+    if ( _update_device_from_cache( old_parent->levels,
+                                    old_parent->cache,
+                                    old_parent->name ) )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_rename() : cannot update <%s> on device\n",
+                    old_parent->name );
+        return -10;
+    }
+
+    // remove "to_remove" from File System (if required)
+    if ( to_remove )
+    {
+        if ( _remove_node_from_fs( to_remove ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_rename() : cannot remove <%s> from FS\n",
+                    to_remove->name );
+            return -11;
+        }
+    }
+
+    // release lock
+    _spin_lock_release( &_fat.fat_lock );
+
+    return 0;
+}  // end _fat_rename()
+
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// The following function implements the giet_fat_mkdir() system call.
+// It creates in file system the directory specified by the "pathname" argument.
+// The Inode-Tree is updated.
+// One cluster is allocated to the new directory.
+// The associated File-Cache is created.
+// The FAT region on block device is updated.
+// The DATA region on block device is updated.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns 0 if success.
+// Returns a negative value if error:
+//   -1  : "Fat not initialised"
+//   -2  : "Path to parent not found"
+//   -3  : "One name in path too long"
+//   -4  : "Directory already exist"
+//   -5  : "No free cluster"
+//   -6  : "Cannot update parent directory"
+//   -7  : "Cannot update parent DATA region"
+//   -8  : "Cannot update FAT region"
+//   -9  : "Cannot update FS-INFO"
+//   -10 : "Cannot update directory DATA region"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_mkdir( char* pathname )
+{
+    fat_inode_t*         inode;            // anonymous inode pointer
+    fat_inode_t*         child;            // searched directory inode pointer
+    fat_inode_t*         parent;           // parent directory inode pointer
+
+#if GIET_DEBUG_FAT
+unsigned int procid  = _get_procid();
+unsigned int x       = procid >> (Y_WIDTH + P_WIDTH);
+unsigned int y       = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
+unsigned int p       = procid & ((1<<P_WIDTH)-1);
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_mkdir() : P[%d,%d,%d] enters for path <%s>\n",
+        x, y, p, pathname );
+#endif
+
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_mkdir() : FAT not initialised\n");
         return -1;
     }
 
-    if ( allocate  )
-    {
-        if ( _fat_allocate( use_irq , fd_id, (required_cluster-current_cluster) ) )
-        {
-            _printf("\n[FAT ERROR] in _fat_write() : fat_allocate failed\n");
-            return -1;
-        }
-    }
-
-    // compute clusters and sectors to be skipped
-    clusters_to_skip = offset / spc;
-    sectors_to_skip  = offset % spc;
+    // takes the lock
+    _spin_lock_acquire( &_fat.fat_lock );
     
-    // get first cluster index 
-    cluster = _fat.fd[fd_id].first_cluster;
+    // get inode
+    unsigned int code = _get_inode_from_path( pathname , &inode );
+
+    if ( code == 2 )  
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_mkdir() : path to parent not found"
+                " for directory <%s>\n", pathname );
+        return -2;
+    }
+    else if ( code == 3 )  
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_mkdir() : one name in path too long"
+                " for directory  <%s>\n", pathname );
+        return -3;
+    }
+    else if ( code == 0 )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_mkdir() : directory <%s> already exist\n",
+                pathname );
+        return -4;
+    }
+    else if ( code == 1 )   // directory not found => create 
+    {
+        parent = inode;
 
 #if GIET_DEBUG_FAT
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] get cluster %x\n",
-        x, y, p, cluster );
-#endif
-
-    // compute index of first cluster to be loaded
-    while ( clusters_to_skip )
-    {
-        cluster = _get_next_cluster( use_irq , cluster );
-        clusters_to_skip--;
-    }
-
-    // variables used in the loop on clusters
-    int             todo_sectors;   // number of sectors still to be loaded
-    unsigned int    lba;            // first sector index on device
-    unsigned int    iter_sectors;   // number of sectors to load in iteration
-    unsigned int    src;            // pointer on target buffer
-
-    // initialize these variables for the first iteration 
-    todo_sectors  = count;
-    src           = (unsigned int)buffer;
-    lba           = cluster_to_lba(cluster) + sectors_to_skip;
-    if( count < (spc - sectors_to_skip) ) iter_sectors = count;
-    else                                  iter_sectors = spc - sectors_to_skip; 
-
-    // loop on the clusters
-    while ( todo_sectors > 0 )
-    {
+_printf("\n[DEBUG FAT] _fat_mkdir() : P[%d,%d,%d] create new directory <%s>\n",
+        x , y , p , pathname );
+#endif
+
+        // get directory name / error check already done by _get_inode_from_path()
+        char name[32];       
+        _get_last_name( pathname , name );
+
+        // allocate one cluster from FAT for the new directory
+        unsigned int cluster;
+        if ( _allocate_one_cluster( &cluster ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_mkdir() : no free cluster"
+                    " for directory <%s>\n" , pathname );
+            return -5;
+        }
+
+        // allocate a new inode and an empty Cache-File 
+        child = _allocate_one_inode( name,
+                                     1,           // it's a directory
+                                     cluster,  
+                                     0,           // size not defined
+                                     0,           // count
+                                     0,           // dentry set by _add_dir_entry()
+                                     1 );         // cache_allocate
+
+        // introduce inode in Inode-Tree
+        _add_inode_in_tree( child , parent );
+ 
+        // allocate and initialise one 4 Kbytes buffer and associated descriptor
+        _allocate_one_buffer( child,
+                              0,            // cluster_id,
+                              cluster );
+
+        _add_special_directories( child, 
+                                  parent );
+
+        // add an entry in the parent directory Cache_file
+        if ( _add_dir_entry( child , parent ) )
+        { 
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_mkdir() : cannot update parent directory"
+                    " for directory <%s>\n" , pathname );
+            return -6;
+        } 
+
+        // update DATA region on block device for parent directory
+        if ( _update_device_from_cache( parent->levels,
+                                        parent->cache,
+                                        parent->name ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_mkdir() : cannot update DATA region "
+                    " for parent of directory <%s>\n", pathname );
+            return -7;
+        }
+
+        // update FAT region on block device
+        if ( _update_device_from_cache( _fat.fat_cache_levels,
+                                        _fat.fat_cache_root,
+                                        "FAT" ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_mkdir() : cannot update FAT region"
+                    " for directory <%s>\n", pathname );
+            return -8;
+        }
+
+        // update FS_INFO sector
+        if ( _update_fs_info() )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_mkdir() : cannot update FS-INFO"
+                    " for directory <%s>\n", pathname );
+            return -9;
+        }
+
+        // update DATA region on block device for the new directory
+        if ( _update_device_from_cache( child->levels,   
+                                        child->cache,
+                                        child->name ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_mkdir() : cannot update DATA region"
+                    " for directory <%s>\n", pathname );
+            return -10;
+        }
+    }  // end create directory
+
+    return 0;
+}  // end _fat_mkdir()
+
+
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// The following function implements the giet_fat_list() system call.
+// It displays the content of a directory identified by the "pathname" argument.
+// It returns an error code if the pathname is not a directory.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns 0 if success.
+// Returns a negative value if error:
+//   -1  : "FAT not initialised
+//   -2  : "Directory not found"
+//   -3  : "Name in path too long
+//   -4  : "Not a directory"
+//   -5  : "Cannot access directory"
+//   -6  : "Name too long truncated"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_list( char*  pathname )
+{
+    fat_inode_t*  inode;
+
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_list() : FAT not initialised\n");
+        return -1;
+    }
 
 #if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] makes an IOC write"
-        "  cluster = %x / buffer = %x / lba = %x / sectors = %d\n",
-        x, y, p, cluster, src, lba, iter_sectors );
-#endif
-
-        if( _fat_ioc_access( use_irq,
-                             0,                 // write
+unsigned int procid  = _get_procid();
+unsigned int x       = procid >> (Y_WIDTH + P_WIDTH);
+unsigned int y       = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
+unsigned int p       = procid & ((1<<P_WIDTH)-1);
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_list() : P[%d,%d,%d] enters for path <%s>\n",
+        x, y, p, pathname );
+#endif
+
+    // get inode 
+    unsigned int code = _get_inode_from_path( pathname , &inode );
+
+    if ( (code == 1) || (code == 2) )  
+    {
+        _printf("\n[FAT ERROR] in _fat_list() : directory <%s> not found\n", pathname );
+        return -2;
+    }
+    if ( code == 3 )
+    {
+        _printf("\n[FAT ERROR] in _fat_list() : name too long in path <%s>\n", pathname );
+        return -3;
+    }
+
+    // check found inode is a directory
+    if ( inode->is_dir == 0 )
+    {
+        _printf("\n[FAT ERROR] in _fat_list() : <%s> is not a directory\n", pathname );
+        return -4;
+    }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_list() : P[%d,%d,%d] found inode for path <%s>\n",
+        x, y, p, pathname );
+#endif
+
+    // scan directory up to end of directory / two embedded loops :
+    // - loop on the clusters allocated to the directory
+    // - loop on the directory entries in each 4 Kbytes buffer
+    unsigned char*     buffer;  
+    fat_cache_desc_t*  pdesc;
+    unsigned int       cluster_id = 0;     // cluster index in directory
+    unsigned int       offset     = 0;     // position in scanned buffer
+    unsigned int       lfn        = 0;     // number of lfn entries
+    unsigned int       nb_entries = 0;     // number of directory entries
+    unsigned int       done       = 0;     // end of directory found
+    unsigned int       attr;               // ATTR field value
+    unsigned int       ord;                // ORD field value
+    char               lfn1[16];           // temporary buffer for string in LFN1
+    char               lfn2[16];           // temporary buffer for string in LFN2
+    char               lfn3[16];           // temporary buffer for string in LFN3
+    char               name[36];           // directory entry full name
+    unsigned int       cluster;            // directory entry cluster index
+    unsigned int       size;               // directory entry size
+    unsigned int       is_dir;             // directory entry is a directory
+    unsigned int       is_vid;             // directory entry is volume_id 
+
+    // TODO : define a method to transfer this information to user mode
+    _printf("\n<%s>   cluster = %x / lba = %x\n", pathname ,
+            inode->cluster , _cluster_to_lba( inode->cluster) );
+
+    while ( done == 0 )
+    {
+        // get one 4 Kytes buffer
+        if ( _get_buffer_from_cache( inode,
+                                     cluster_id,
+                                     &pdesc ) ) 
+        {
+            _printf("\n[FAT ERROR] in _fat_list() : cannot access <%s>\n", pathname );
+            return -5;
+        }
+        buffer = pdesc->buffer;
+
+        // scan this 4 Kbytes buffer
+        while ( (offset < 4096)  && (done == 0) )
+        {
+            attr = _read_entry( DIR_ATTR , buffer + offset , 0 );   
+            ord  = _read_entry( LDIR_ORD , buffer + offset , 0 );
+
+            if (ord == NO_MORE_ENTRY)                 // no more entry in directory => break
+            {
+                done = 1;
+            }
+            else if ( ord == FREE_ENTRY )             // free entry => skip
+            {
+                offset = offset + 32;
+            }
+            else if ( attr == ATTR_LONG_NAME_MASK )   // LFN entry => get partial names
+            {
+                unsigned int seq = ord & 0x3;
+                lfn = (seq > lfn) ? seq : lfn;   
+                if      ( seq == 1 ) _get_name_from_long( buffer + offset, lfn1 );
+                else if ( seq == 2 ) _get_name_from_long( buffer + offset, lfn2 );
+                else if ( seq == 3 ) _get_name_from_long( buffer + offset, lfn3 );
+                offset = offset + 32;
+            }
+            else                                 // NORMAL entry
+            {
+                if      ( lfn == 0 )
+                {
+                    _get_name_from_short( buffer + offset , name );
+                }
+                else if ( lfn == 1 )
+                {
+                    _strcpy( name , lfn1 );
+                }   
+                else if ( lfn == 2 ) 
+                {
+                    _strcpy( name      , lfn1 );
+                    _strcpy( name + 13 , lfn2 );
+                }
+                else if ( lfn == 3 ) 
+                {
+                    _strcpy( name      , lfn1 );
+                    _strcpy( name + 13 , lfn2 );
+                    _strcpy( name + 26 , lfn3 );
+                }
+                    
+                is_dir  = ((attr & ATTR_DIRECTORY) == ATTR_DIRECTORY);
+                is_vid  = ((attr & ATTR_VOLUME_ID) == ATTR_VOLUME_ID);
+                size    = (_read_entry( DIR_FILE_SIZE   , buffer + offset , 1 )      ) ;
+                cluster = (_read_entry( DIR_FST_CLUS_HI , buffer + offset , 1 ) << 16) |
+                          (_read_entry( DIR_FST_CLUS_LO , buffer + offset , 1 )      ) ;
+
+                if ( is_vid == 0 )
+                {
+                    // TODO : define a method to transfer this information to user mode
+                    if (is_dir) _printf("  DIR  | size = %X | cluster = %X | %s\n",
+                                        size , cluster, name );
+                    else        _printf("  FILE | size = %X | cluster = %X | %s\n",
+                                        size , cluster, name );
+                    nb_entries++;
+                }
+                
+                offset = offset + 32;
+                lfn    = 0;
+            }
+        }  // end loop on directory entries
+
+        if ( done == 0 )
+        {
+            cluster_id++;
+            offset = 0;
+        }
+    }  // end loop on buffers
+
+    // TODO : define a method to transfer this information to user mode
+    _printf("  total = %d entries\n", nb_entries );
+
+    return 0;
+} // end _fat_list()
+
+
+
+
+
+///////////////////////////////////////////////////////////////////////////////
+// This functiond load a file identified by the "pathname" argument into the
+// memory buffer defined by the "buffer_vbase" and "buffer_size" arguments.
+// It is intended to be called by the boot-loader, as it does not use the
+// dynamically allocated FAT structures (Inode-Tree, Fat_Cache or File-Cache,
+// File-Descriptor-Array).
+// It uses only the 512 bytes buffer defined in the FAT descriptor. 
+///////////////////////////////////////////////////////////////////////////////
+// Returns  0 if success.
+// Returns negative value if error:
+//  -1  : "FAT not initialised"
+//  -2  : "File not found"
+//  -3  : "Buffer too small"
+//  -4  : "Cannot access block device"
+//  -5  : "Cannot access FAT on block device"
+///////////////////////////////////////////////////////////////////////////////
+int _fat_load_no_cache( char*        pathname,
+                        unsigned int buffer_vbase,  
+                        unsigned int buffer_size ) 
+{
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_load_no_cache() : FAT not initialised\n");
+        return -1;
+    }
+
+    unsigned int  file_size;
+    unsigned int  cluster;
+
+#if GIET_DEBUG_FAT
+unsigned int procid  = _get_procid();
+unsigned int x       = procid >> (Y_WIDTH + P_WIDTH);
+unsigned int y       = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
+unsigned int p       = procid & ((1<<P_WIDTH)-1);
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_load_no_cache() : P[%d,%d,%d] enters for file <%s>\n",
+        x , y , p , pathname );
+#endif
+
+    // get file size, and cluster index in FAT
+    if ( _file_info_no_cache( pathname,
+                              &cluster,
+                              &file_size ) )
+    {
+        _printf("\n[FAT ERROR] in _fat_load_no_cache() : file <%s> not found\n",
+        pathname );
+        return -2;
+    }
+
+    // check buffer size
+    if ( file_size > buffer_size )
+    {
+        _printf("\n[FAT ERROR] in _fat_load_no_cache() : buffer too small : "
+                "file_size = %x / buffer_size = %x", file_size , buffer_size );
+        return -3;
+    }
+
+    // compute total number of clusters to read
+    unsigned int nb_clusters = file_size >> 12;
+    if ( file_size & 0xFFF ) nb_clusters++;
+
+    // initialise buffer address
+    unsigned int dst = buffer_vbase;
+
+    // loop on the clusters containing the file
+    while ( nb_clusters > 0 )
+    {
+        unsigned int lba = _cluster_to_lba( cluster );
+
+        if( _fat_ioc_access( 0,         // no descheduling
+                             1,         // read
                              lba, 
-                             src,               // source buffer address
-                             iter_sectors ) )   // number of sectors
-        {
-            _printf("\n[FAT ERROR] in _fat_write() cannot write block %x\n", lba );
-            return -1;
+                             dst, 
+                             8 ) )      // 8 blocks
+        {
+            _printf("\n[FAT ERROR] in _fat_no _cache_read() : cannot load lba %x", lba );
+            return -4;
         }
          
+
+        // compute next cluster index
+        unsigned int next;
+        if ( _next_cluster_no_cache( cluster , &next ) )
+        {
+            _printf("\n[FAT ERROR] in _fat_no _cache_read() : cannot get next cluster "
+                    " for cluster = %x\n", cluster );
+            return -5;
+        }
+        
         // update variables for next iteration
-        cluster      = _get_next_cluster( use_irq , cluster );
-        todo_sectors = todo_sectors - iter_sectors;
-        src          = src + (iter_sectors << 9);
-        lba          = cluster_to_lba(cluster);
-        if ( todo_sectors > spc ) iter_sectors = spc;
-        else                      iter_sectors = todo_sectors;
-    }
-
-    // Update structure file descriptor, field file_size with
-    // the new file size if the file is bigger than the previous file
-    if ( ( offset + count ) > file_sectors )
-    {
-        _fat.fd[fd_id].file_size = (count + offset) << 9;
-    }
-
-    // Update entry of directory with the new value 
-    // of file size (Field : DIR_FILE_SIZE)
-    if ( _update_entry( use_irq, fd_id , DIR_FILE_SIZE , _fat.fd[fd_id].file_size ) )
-    {
-        _printf("\n[FAT ERROR] in _fat_write() update entry failed\n");
-        return -1;
+        nb_clusters = nb_clusters - 1;
+        dst         = dst + 4096;
+        cluster     = next;
     }
          
-    // returns number of sectors actually transfered
-    return count;
-}  // end _fat_write()
-
-/////////////////////////////////////////////////////////////////////////////////
-// Return stats of a file identified by "fd". 
-// (Only the file_size in sectors for this moment)
-/////////////////////////////////////////////////////////////////////////////////
-// Returns file size (on sectors) on success, -1 on failure.
-/////////////////////////////////////////////////////////////////////////////////
-int _fat_fstat( unsigned int fd_id )
-{
-    unsigned int file_size    = 0;
-    unsigned int file_sectors = 0;
-
-    if( (fd_id < GIET_OPEN_FILES_MAX) )
-    {
-        file_size = _fat.fd[fd_id].file_size;
-
-        if ( file_size & 0x1FF ) file_sectors = (file_size >> 9) + 1;
-        else                     file_sectors = (file_size >> 9); 
-
-        return file_sectors;
-    }
-    else
-    {
-        _printf("\n[FAT ERROR] in _fat_fstat() : illegal file descriptor index\n");
-        return -1;
-    } 
-} // end _fat_fstat()
-
-/////////////////////////////////////////////////////////////////////////////////
-// Close the file identified by the file_descriptor index. 
-/////////////////////////////////////////////////////////////////////////////////
-// Returns 0 on success, -1 on failure.
-/////////////////////////////////////////////////////////////////////////////////
-int _fat_close( unsigned int fd_id )
-{
-    if( (fd_id < GIET_OPEN_FILES_MAX) )
-    {
-        _fat.fd[fd_id].used = 0;
-        return 0;
-    }
-    else
-    {
-        _printf("\n[FAT ERROR] in _fat_close() : illegal file descriptor index\n");
-        return -1;
-    } 
-} // end fat_close()
-
-/////////////////////////////////////////////////////////////////////////////////
-// The following function implement the user_level system call.
-// The flags argument is not used, as file access modes are not implemented yet.
-/////////////////////////////////////////////////////////////////////////////////
-// Return the file descriptor index if success / return -1 if failure
-/////////////////////////////////////////////////////////////////////////////////
-int _fat_user_open( char*  pathname,         // absolute pathname from root
-                    unsigned int flags )     // unused: TODO
-{
-    return _fat_open( 1,        // use descheduling mode if possible
-                      pathname, 
-                      0 );      // no creation if not found
-}
-
-/////////////////////////////////////////////////////////////////////////////////
-// The following function implement the user_level system call.
-// This function should be modified to respect the UNIX specification.
-/////////////////////////////////////////////////////////////////////////////////
-// Return number of sectors actually transfered if success / return -1 if failure
-/////////////////////////////////////////////////////////////////////////////////
-int _fat_user_read( unsigned int fd,        // file descriptor index
-                    void*        buffer,    // destination buffer
-                    unsigned int count,     // number of sectors to read
-                    unsigned int offset )   // number of sectors to skip
-{
-    return _fat_read( 1,        // use descheduling mode if possible
-                      fd,
-                      buffer,  
-                      count,  
-                      offset );
-}
-
-/////////////////////////////////////////////////////////////////////////////////
-// The following function implement the user_level system call.
-// This function should be modified to respect the UNIX specification. 
-/////////////////////////////////////////////////////////////////////////////////
-// Return number of sectors actually transfered if success / return -1 if failure
-/////////////////////////////////////////////////////////////////////////////////
-int _fat_user_write( unsigned int fd,       // file descriptor
-                     void*        buffer,   // source buffer
-                     unsigned int count,    // number of sectors to write
-                     unsigned int offset )  // number of sectors to skip on file
-{
-    return _fat_write( 1,       // use descheduling mode if possible
-                       fd,
-                       buffer,  
-                       count,  
-                       offset );
-}
-
-/////////////////////////////////////////////////////////////////////////////////
-int _fat_user_lseek( unsigned int fd_id,
-                     unsigned int offset,
-                     unsigned int whence )
-{
-    _printf("\n[GIET ERROR] _fat_user_lseek() not implemented\n");
-    _exit();
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_load_no_cache() : P[%d,%d,%d] loaded <%s> at vaddr = %x"
+        " / size = %x\n", x , y , p , pathname , buffer_vbase , file_size );
+#endif
+
     return 0;
-}
+}  // end _fat_load_no_cache() 
+
 
 
